<script>
import GitApiCall from '@/api/gitApi'

export default {
  name: 'JobSetupFormComponent',
  components: {
  },
  props: {
    projectId: {
      type: Number,
      default: 0,
    },
    step: {
      type: Object,
    },
    inputs: {
      type: Object,
    },
  },
  data() {
    return {
      pipelineId: 0,
      s_spinning: false,
      c_spinning: false,
      spinning: false,
      jobVars: {},
    }
  },
  watch: {},
  mounted() {
    this.pipelineId = this.$route.params.pipeline_id
  },
  methods: {
    async playJobButton(jobId) {
      this.saving = true
      this.s_spinning = true

      const envVars = []

      Object.keys(this.jobVars).forEach(value => {
        console.log('form.EnvVars[key]:', value)
        console.log('form.EnvVars[value]:', this.jobVars[value])
        envVars.push({
          key: value,
          value: this.jobVars[value],
        })
      })

      console.log('Continue button: ', jobId)

      const git = new GitApiCall()
      try {
        const playJob = await git.playJob(this.projectId, jobId, envVars)

        console.log('playJob: ', JSON.parse(JSON.stringify(playJob)))
      }
      catch (error) {
        console.log('error getProjects', error)
      }
      this.s_spinning = false
    },
    async cancelJob(jobId) {
      this.saving = true
      this.c_spinning = true

      const git = new GitApiCall()
      try {
        // let playResponse = await git.playJob(this.projectId, jobId, [])
        const cancelResponse = await git.cancelJob(this.projectId, jobId)

        console.log('cancelPipeline: ', cancelResponse.data)
      }
      catch (error) {
        console.error('error cancelPipeline', error)
      }
      this.c_spinning = false
    },
  },
}
</script>

<template>
  <VDivider />
  <VForm
    class="mt-6"
    style="min-width: 100%;"
    @submit.prevent
  >
    <VRow
      v-for="(input, index) in inputs"
      v-if="step.status === 'manual'"
      :key="index"
      class="mb-3 pl-3 pr-5"
    >
      <!--  sm="6" -->
      <VCol
        class="pa-0"
        cols="12"
      >
        <VTextField
          v-model="jobVars[input.name]"
          :label="input.label !== undefined ? input.label : input.name"
          :name="input.name"
          :placeholder="input.value"
          dense
          outlined
        />
      </VCol>
    </VRow>
    <VRow
      class="mb-3 pl-3 pr-3"
      justify="end"
    >
      <VCol
        cols="auto"
        class="pa-0"
      >
        <VBtnGroup>
          <VBtn
            v-if="step.status === 'manual'"
            color="success"
            variant="text"
            size="x-small"
            :loading="s_spinning"
            :disabled="saving"
            @click="playJobButton(step.id)"
          >
            Continue
          </VBtn>
          <VBtn
            v-if="step.status === 'manual'"
            color="error"
            variant="text"
            size="x-small"
            :loading="c_spinning"
            :disabled="saving"
            @click="cancelJob(step.id)"
          >
            Cancel
          </VBtn>
        </VBtnGroup>
      </VCol>
    </VRow>
  </VForm>
</template>

<style scoped></style>
